#ifndef BOOKNUM_H
#define BOOKNUM_H

#define	GENESIS		0
#define DEUTERONOMY 4
#define MALACHI		38
#define	MATTHEW		39
#define	REVELATION	65



class bookNum {
	public:
		bookNum(); //default constructor
		bookNum(int i); //constructor
		int current();
		BOOL next();
		void reset();

	private:
		int currentBook;
		int	method;
		int min;
		int max;

};




bookNum::bookNum() : method(0) {
	//Default Whole bible
	min = GENESIS;
	max = REVELATION;
	currentBook = min;
}

bookNum::bookNum(int i) : method(i) {
	//Default Whole bible
	min = GENESIS;
	max = REVELATION;

	if (method == 1) {
		//New Testament
		min = MATTHEW;
		max = REVELATION;
	} 
	else if (method == 2) {
		//Old Testament
		min = GENESIS;
		max = MALACHI;
	}
	else if (method == 3) {
		//Gospels
		min = MATTHEW;
		max = REVELATION;
	}
	else if (method == 4) {
		//Torah
		min = GENESIS;
		max = DEUTERONOMY;
	}
	else {
		method = 0;
	}

	currentBook = min;

}

void bookNum::reset() {
	currentBook = min;
}

int bookNum::current() {
	return currentBook;
}

	
BOOL bookNum::next() {
	if (currentBook < max) {
		currentBook++;
		return TRUE;
	} else {
		return FALSE;
	}

}



#endif BOOKNUM_H