// whbbible.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "whbbible.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>
#include <stdio.h>
//#include <Wingdi.h>
#include "searchPage.h"
#include "bookNum.h"
#include "bibles.h"

//#include <Rapi.h>


// Global Variables:
HINSTANCE			g_hInst;				// The current instance
HWND				g_hwndCB;					// The command bar handle

static SHACTIVATEINFO s_sai;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	SearchBox		(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	VerseBox		(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	ChapterBox		(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	WelcomeBox		(HWND, UINT, WPARAM, LPARAM);
HWND				CreateRpCommandBar(HWND);

int		giTokens = 0; //Number of Tokens parsed.
char	gszCharTokenString[MAX_TOKENSTR]; //Holds string of Tokens
char *	gpszCharTokens[NUM_TOKENS];  //Pointer to location of token in gszTokenString
TCHAR	gszTokenString[MAX_TOKENSTR]; //Holds string of Tokens
TCHAR	gszOriginalTokenString[MAX_TOKENSTR]; //Holds string of Tokens
TCHAR*	gpszTokens[NUM_TOKENS];  //Pointer to location of token in gszTokenString
short	giTokensLen[NUM_TOKENS]; //Length of individual token
BOOL	gbSearch = FALSE;
int		gSearchPageNum = 0;
int		gSearchPageNumMax = 0;
int		gNumFound = 0;
//short	gBookNum = 0;
int		giLastSelectedItem = 0;
HWND	gWelcomeDialog;
HFONT	g_hfFont = NULL;
LOGFONT g_logFont;
int		g_iWhichBooks;
BOOL	g_bConcordanceView = TRUE;
BOOL	g_hwndMatchCase = FALSE;
BOOL	g_hwndExactMatch = FALSE;
int		g_iBibleVersion = 0;
//TCHAR	gpszChapterText[MAX_CHAPTER];
TCHAR	*gpszChapterText = NULL;

Bibles gBibles;


typedef struct _ChapterDisplay {
	int iVersion;
	int iBook;
	int iChapter;
	int iVerse;
} CHAPTERDISPLAY;

CHAPTERDISPLAY g_ChapterDisplay;

searchPage gPages;

//int			iSearchLength[MAX_RESULTS];
//int			iSearchColumnWidth = 0;

	
SEARCHTYPE	gpszSearch[MAX_RESULTS];// = {0, FALSE, NULL};
//int			iSearchResultsNum = 0;
SEARCHTYPE gLastResults;
TCHAR	gszLastResults[50];



int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WHBBIBLE);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    It is important to call this function so that the application 
//    will get 'well formed' small icons associated with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_WHBBIBLE));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

//
//  FUNCTION: InitInstance(HANDLE, int)
//
//  PURPOSE: Saves instance handle and creates main window
//
//  COMMENTS:
//
//    In this function, we save the instance handle in a global variable and
//    create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd = NULL;
	TCHAR	szTitle[MAX_LOADSTRING];			// The title bar text
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name

	g_hInst = hInstance;		// Store instance handle in our global variable
	// Initialize global strings
	LoadString(hInstance, IDC_WHBBIBLE, szWindowClass, MAX_LOADSTRING);
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);


	//If it is already running, then focus on the window
	hWnd = FindWindow(szWindowClass, szTitle);	
	if (hWnd) 
	{
		// set focus to foremost child window
		// The "| 0x01" is used to bring any owned windows to the foreground and
		// activate them.
		SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
		return 0;
	} 

	MyRegisterClass(hInstance, szWindowClass);
	
	RECT	rect;
	GetClientRect(hWnd, &rect);
	
	hWnd = CreateWindow(
		szWindowClass, 
		szTitle, 
		WS_VISIBLE,	
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 
		NULL, 
		NULL, 
		hInstance, 
		NULL);
	if (!hWnd)
	{	
		return FALSE;
	}
	//When the main window is created using CW_USEDEFAULT the height of the menubar (if one
	// is created is not taken into account). So we resize the window after creating it
	// if a menubar is present
	{
		RECT rc;
		GetWindowRect(hWnd, &rc);
		rc.bottom -= MENU_HEIGHT*2;
		if (g_hwndCB)
			MoveWindow(hWnd, rc.left, rc.top, rc.right, rc.bottom, FALSE);
	}


	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}

void myWMSetFont(HWND hWnd) {
	//HDC hdc;
	HFONT hFont;

	ZeroMemory(&g_logFont,sizeof(LOGFONT));
	g_logFont.lfHeight = -11; 
	g_logFont.lfWidth = 0; 
	g_logFont.lfEscapement = 0; 
	g_logFont.lfOrientation = 0; 
	g_logFont.lfWeight = FW_NORMAL; 
	g_logFont.lfItalic = FALSE; 
	g_logFont.lfUnderline = FALSE; 
	g_logFont.lfStrikeOut = FALSE; 
	g_logFont.lfCharSet = DEFAULT_CHARSET; 
	g_logFont.lfOutPrecision = OUT_DEFAULT_PRECIS; 
	g_logFont.lfClipPrecision = CLIP_DEFAULT_PRECIS; 
	g_logFont.lfQuality = DEFAULT_QUALITY; 
	g_logFont.lfPitchAndFamily = DEFAULT_PITCH; 
	g_logFont.lfFaceName[0] = NULL;


	hFont = CreateFontIndirect(&g_logFont);

	if(hFont) {
		DeleteObject(g_hfFont);
		g_hfFont = hFont;
	}
	else {
		MessageBox(hWnd, TEXT("Font creation failed!"), TEXT("Error"), MB_OK | MB_ICONEXCLAMATION);
	}   

		//SendMessage(hWnd, WM_SETFONT, (WPARAM)g_hfFont, 0);
//	}

	//hdc = GetDC(hWnd);	
	//SelectObject(hdc, (HGDIOBJ) g_hfFont);
	//ReleaseDC(hWnd, hdc);
}
	


/****************************************************************************
*                                                                          *
*  FUNCTION   : HandlePopupMenu (hwnd, point)                              *
*                                                                          *
*  PURPOSE    : Handles the display of the "floating" popup that appears   *                                                           *
*               on a mouse click in the app's client area.                 *
*                                                                          *
****************************************************************************/
VOID APIENTRY HandlePopupMenu (HWND hwnd, POINT point)
                               
{
  HMENU hMenu;
  HMENU hMenuTrackPopup;
  
  /* Get the menu for the popup from the resource file. */
  hMenu = LoadMenu (g_hInst, MAKEINTRESOURCE(IDM_SEARCHMENU));
  if (!hMenu)
    return;
  
    /* Get the first menu in it which we will use for the call to
    * TrackPopup(). This could also have been created on the fly using
    * CreatePopupMenu and then we could have used InsertMenu() or
    * AppendMenu.
  */
  hMenuTrackPopup = GetSubMenu (hMenu, 0);
  
  /* Convert the mouse point to screen coordinates since that is what
  * TrackPopup expects.
  */
  ClientToScreen (hwnd, (LPPOINT)&point);
  
  /* Draw and track the "floating" popup */
  TrackPopupMenu (hMenuTrackPopup, 0, point.x, point.y, 0, hwnd, NULL);
  
  /* Destroy the menu since were are done with it. */
  DestroyMenu (hMenu);
}




/****************************************************************************
* 
*    FUNCTION: CreateEditControl(HWND)
*
*    PURPOSE:  Creates the list view window and initializes it
*
****************************************************************************/
HWND CreateEditControl(HWND hWndParent)                                     
{
	HWND hWndEditControl;      		// handle to list view window
	RECT rcl;           		// rectangle for setting size of window

	GetClientRect(hWndParent, &rcl);

// Specify the window style for the edit control.
DWORD dwStyle = WS_CHILD | WS_VISIBLE | WS_HSCROLL | ES_READONLY | 
                ES_LEFT | ES_MULTILINE | ES_NOHIDESEL | 
                ES_AUTOVSCROLL;  

// Create the window for the edit control window.
hWndEditControl = CreateWindow (
                TEXT("edit"),   // Class name
                NULL,           // Window text
                dwStyle,        // Window style
				rcl.top, 
				rcl.left,
				rcl.right - rcl.left, 
				rcl.bottom - rcl.top,
                hWndParent,           // Window handle to the parent window
                (HMENU) EDITCONTROL, // Control identifier
                g_hInst,        // Instance handle
                NULL);          // Specify NULL for this parameter when 
                                // you create a control

	return (hWndEditControl);
}




HWND CreateEditBox (HWND hWndParent) {

	HWND hWndEdit;      		// handle to list view window
	RECT rcl;   
//	TCHAR szText[1000];

	// Ensure that the common control DLL is loaded.
	InitCommonControls();
	
	// Get the size and position of the parent window.
	GetClientRect(hWndParent, &rcl);

	// Specify the window style for the edit control.
	DWORD dwStyle = WS_CHILD | WS_VISIBLE | WS_VSCROLL | 
                WS_BORDER | ES_LEFT | ES_MULTILINE | ES_NOHIDESEL | 
                ES_AUTOVSCROLL | ES_WANTRETURN | ES_READONLY;  

	// Create the window for the edit control window.
	hWndEdit = CreateWindow (
                TEXT("EDIT"),   // Class name
                NULL,           // Window text
                dwStyle,        // Window style
                rcl.left,              // x-coordinate of the upper-left corner
                rcl.top,              // y-coordinate of the upper-left corner
                rcl.right - rcl.left,  // Width of the window for the edit
                                // control
                rcl.bottom - rcl.top,  // Height of the window for the edit
                                // control
                hWndParent,          // Window handle to the parent window
                (HMENU)ID_CHAPTER_TEXT, // Control identifier
                g_hInst,        // Instance handle
                NULL);          // Specify NULL for this parameter when 
                                // you create a control

	return (hWndEdit);


}


/****************************************************************************
* 
*    FUNCTION: CreateListView(HWND)
*
*    PURPOSE:  Creates the list view window and initializes it
*
****************************************************************************/
HWND CreateListView (HWND hWndParent)                                     
{
	HWND hWndList;      		// handle to list view window
	RECT rcl;           		// rectangle for setting size of window
	HICON hIcon;        		// handle to an icon
	HIMAGELIST hImage;
//	HDC hdc;
	int index;					// index used in for loops
	// large icons
	LVCOLUMN lvC;				// list view column structure
	TCHAR szText[MAX_PATH];		// place to store some text
	LVITEM lvI;				// list view item structure
	//int iSubItem;				// index into column header string table
	//SIZE textSize;
//	int MaxSize = 0;
//	LOGFONT logFont;
//	HFONT hFont;
//    HFONT hf;
//    HDC hdc;
 //   long lfHeight;


		// Ensure that the common control DLL is loaded.
	InitCommonControls();
	
	// Get the size and position of the parent window.
	GetClientRect(hWndParent, &rcl);

	hWndList = CreateWindowEx( 0L,
		WC_LISTVIEW,                // list view class
		TEXT("Search Results"),                         // no default text
		WS_VISIBLE | WS_CHILD | WS_BORDER | LVS_REPORT | 
		LVS_NOCOLUMNHEADER | LVS_NOSORTHEADER | //LVS_OWNERDRAWFIXED |
		LVS_SINGLESEL | WS_EX_CLIENTEDGE | WS_VSCROLL | WS_HSCROLL,	// styles
		rcl.top, 
		rcl.left,
		rcl.right - rcl.left, 
		rcl.bottom - rcl.top,
		hWndParent,
		(HMENU) ID_LISTVIEW,
		g_hInst,
		NULL );



//	hdc = GetDC(hWndList);	
	

/*
	
	SelectObject(hdc, (HGDIOBJ) hFont);
	SendMessage(hWndList, WM_SETFONT, (WPARAM)hFont, 0);

*/


	// Initialize the list view window.
	// First initialize the image lists you will need:
    // create image lists for the small and the large icons.
	
	hImage = ImageList_Create( BITMAP_WIDTH, BITMAP_HEIGHT,	FALSE, 2, 0 );
	
	hIcon = LoadIcon ( g_hInst, MAKEINTRESOURCE(IDI_CROSS));
	if (ImageList_AddIcon(hImage, hIcon) == -1) 
			return NULL;
	
	hIcon = LoadIcon ( g_hInst, MAKEINTRESOURCE(IDI_CROSS_BLANK));
	if (ImageList_AddIcon(hImage, hIcon) == -1) 
			return NULL;
	
	// Associate the image lists with the list view control.
	ListView_SetImageList(hWndList, hImage, LVSIL_SMALL);
	
	//ListView_SetImageList(hWndList, hImage, LVSIL_NORMAL);


		
		
		
		
		
		
		/*
	wsprintf(szText, TEXT("rcitem: top:%ld bot:%ld lef:%ld rig:%ld id: %d"),
		rcl.top, 
		rcl.left,
		rcl.right - rcl.left, 
		rcl.bottom - rcl.top
		);

	MessageBox (NULL, szText, NULL, MB_OK );
	*/


	
//ListView_SetCallbackMask(hWndList, LVIS_SELECTED | LVIS_FOCUSED);


/*
	hWndList = CreateWindowEx( 0L,
		WC_LISTVIEW,                // list view class
		TEXT("Search Results"),                         // no default text
		WS_VISIBLE | WS_CHILD | WS_BORDER | LVS_REPORT | 
		LVS_NOCOLUMNHEADER | LVS_NOSORTHEADER | 
		LVS_SINGLESEL | WS_EX_CLIENTEDGE | WS_VSCROLL | WS_HSCROLL,	// styles
		rcl.top, 
		rcl.left,
		rcl.right - rcl.left, 
		rcl.bottom - rcl.top,
		hWndParent,
		(HMENU) ID_LISTVIEW,
		g_hInst,
		NULL );
*/	
	if (hWndList == NULL )
		return NULL;

	//ListView_SetBkColor(hWndList, 0x00cccccc);
	
//	hdc = GetDC(hWndList);




	// Now initialize the columns you will need.
	// Initialize the LV_COLUMN structure.
	// The mask specifies that the fmt, width, pszText, and subitem members 
	// of the structure are valid,

	lvC.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvC.fmt = LVCFMT_LEFT;  // left-align column
	lvC.cx = rcl.right - rcl.left - 10; //75;            // width of column in pixels
	lvC.pszText = szText;
	
	// Add the columns.
//	for (index = 0; index <= NUM_COLUMNS; index++)
//	{

//		lvC.cx = COL_WIDTH[index];            // width of column in pixels
	lvC.iSubItem = 0; //index;
	index = 0;

	LoadString( g_hInst, IDS_SEARCHAGAIN, szText, sizeof(szText));
	if (ListView_InsertColumn(hWndList, index, &lvC) == -1)
		return NULL;

//	}
	
	// Finally, add the actual items to the control.
	// Fill out the LV_ITEM structure for each of the items to add to the list.
	// The mask specifies the the pszText, iImage, lParam and state
	// members of the LV_ITEM structure are valid.
	lvI.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE;
	lvI.state = 0;      
	lvI.stateMask = 0;  
	
	/*
	for (index = 0; index < NUM_ITEMS; index++)
	{
		lvI.iItem = index;
		lvI.iSubItem = 0;
		// The parent window is responsible for storing the text. 
		// The list view control will send an LVN_GETDISPINFO 
		// when it needs the text to display.
		lvI.pszText = LPSTR_TEXTCALLBACK; 
		lvI.cchTextMax = MAX_VERSETEXT;
		//lvI.iImage = index;
		lvI.lParam = (LPARAM) SearchWindow[index]; //&rgSearch[index];
		
		if (ListView_InsertItem(hWndList, &lvI) == -1)
			return NULL;
		
		ListView_SetItemText( hWndList,	index, 1, LPSTR_TEXTCALLBACK);
*/
		/*
		for (iSubItem = 1; iSubItem < NUM_COLUMNS; iSubItem++)
		{
			ListView_SetItemText( hWndList,
				index,
				iSubItem,
				LPSTR_TEXTCALLBACK);
		}
		*/
/*
		wsprintf(szText, TEXT("%s %u:%u - %s"), &rgSearch[index].szBook, &rgSearch[index].iChapter, &rgSearch[index].iVerse, &rgSearch[index].szVerseText);
		if (GetTextExtentPoint(hdc, szText, _tcslen(szText), &textSize )) {
			if (textSize.cx > MaxSize) {
				MaxSize = textSize.cx;
				ListView_SetColumnWidth(hWndList, 0, LVSCW_AUTOSIZE);
			}
		}
*/
	
	  //wsprintf(szText, TEXT("Size x:%u y:%u"), MaxSize, rcl.right - rcl.left);
	//MessageBox (NULL, szText, NULL, MB_OK );
	//}
	//UpdateWindow(hWndList);
	return (hWndList);
}





/****************************************************************************
* 
*    FUNCTION: ListViewCompareProc(LPARAM, LPARAM, LPARAM)
*
*    PURPOSE: Callback function that sorts depending on the column click 
*
****************************************************************************/
int CALLBACK ListViewCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	return 0;

}

/****************************************************************************
* 
*    FUNCTION: NotifyHandler(HWND, UINT, UINT, LONG)
*
*    PURPOSE: This function is the handler for the WM_NOTIFY that is 
*    sent to the parent of the list view window.
*
****************************************************************************/
LRESULT NotifyHandler( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LV_DISPINFO *pLvdi = (LV_DISPINFO *)lParam;
	NM_LISTVIEW *pNm = (NM_LISTVIEW *)lParam;
	SEARCHTYPE *pSearch = (SEARCHTYPE *)(pLvdi->item.lParam);
	//RECT rc;
	//POINT pt;
	//HMENU hMenu;
	//HMENU hMenuTrackPopup;
	//static TCHAR szText[100];
	
	//If this isnt for the List Main Return
	if (wParam != ID_LISTVIEW)
		return 0L;
	
	switch(pLvdi->hdr.code)
	{

	
		case LVN_GETDISPINFO:
			switch (pLvdi->item.iSubItem) {
				case 0:     // Book
					//wsprintf(szText, TEXT("%s %u:%u - %s"), pSearch->szBook, pSearch->iChapter, pSearch->iVerse, pSearch->szVerseText);
					pLvdi->item.pszText = (TCHAR *) pSearch->str;
					break;
				
				default:
					break;
			}

			break;

			

		case LVN_BEGINLABELEDIT:
			{
				
				//MessageBox(hWnd, TEXT("LVN_BEGINLABELEDIT"), TEXT("Error"), MB_OK | MB_ICONSTOP);
				//HWND hWndEdit;
				SendMessage(hWnd, WM_CANCELMODE, 0, 0); //no change
				return 1L;
				// Get the handle to the edit box.
				//hWndEdit = (HWND)SendMessage(hWnd, LVM_GETEDITCONTROL, 0, 0);
				// Limit the amount of text that can be entered.
				//SendMessage(hWndEdit, EM_SETLIMITTEXT, (WPARAM)0, 0); //no change
			}
			break;
			
		case LVN_ENDLABELEDIT:
				//MessageBox(hWnd, TEXT("LVN_ENDLABELEDIT"), TEXT("Error"), MB_OK | MB_ICONSTOP);
			// Save the new label information
//            if ((pLvdi->item.iItem != -1) && 
  //              (pLvdi->item.pszText != NULL))
	//			lstrcpy(pSearch->szBook, pLvdi->item.pszText);
			break;

		case LVN_ITEMACTIVATE:
				//MessageBox(hWnd, TEXT("LVN_ITEMACTIVATE"), TEXT("Error"), MB_OK | MB_ICONSTOP);
				giLastSelectedItem = pNm->iItem;
				//HandlePopupMenu(hWnd, pNm->ptAction);
				g_ChapterDisplay.iVersion = gpszSearch[giLastSelectedItem].version;
				g_ChapterDisplay.iBook = gpszSearch[giLastSelectedItem].book;
				g_ChapterDisplay.iChapter = gpszSearch[giLastSelectedItem].chapter;
				DialogBox(g_hInst, (LPCTSTR)IDD_CHAPTERBOX, hWnd, (DLGPROC)ChapterBox);

			break;

			
		/*

		case LVN_ITEMCHANGING:
				MessageBox(hWnd, TEXT("LVN_ITEMCHANGING"), TEXT("Error"), MB_OK | MB_ICONSTOP);
			break;

		case LVN_MARQUEEBEGIN:
				MessageBox(hWnd, TEXT("LVN_MARQUEEBEGIN"), TEXT("Error"), MB_OK | MB_ICONSTOP);
			break;


		case LVN_KEYDOWN:
				MessageBox(hWnd, TEXT("LVN_KEYDOWN"), TEXT("Error"), MB_OK | MB_ICONSTOP);
			break;

		case LVN_COLUMNCLICK:
			// The user clicked a column header - sort by this criterion.
			ListView_SortItems( pNm->hdr.hwndFrom, ListViewCompareProc,	(LPARAM)(pNm->iSubItem));
			break;
*/			
		default:
			break;
		}
	return 0L;
}




/*
bool is_substring(char *full_string, char *scan_string) {
 	if(sizeof(scan_string) > sizeof(full_string))
 		return false;
 	if(full_string == full_string)
 		return true;
 	for(int x=0; x < (sizeof(full_string)/sizeof(char))-(sizeof(scan_string)/sizeof(char)); x++)
	if(toupper(full_string[x]) == toupper(scan_string[0]))
	{
		int z=x+1;
		for(int y=1; scan_string[y]!=null; y++)
		{
			if(toupper(scan_string[y])!=toupper(full_string[z]))
				break;
			z++;
		}
		if(scan_string[y]==null)
			return true;
	}
return false;
}

char* lowerstr(char str[]) { 
	for (char* ptr = str; *ptr; ++ptr) 
		*ptr = tolower(*ptr); 
	return str; 
}
*/


//
//	Caseless compare of two strings
//
//
char * ncstrstr( char * string, char * substr) {
	int iIndex = 0;
	int iIndexB = 0;
	int iSubLen = strlen(substr);
	int iLen = strlen(string) - iSubLen;
	int iFound = 0;
	
	if (iLen < 0)
		return FALSE; //substring is too big

	for (iIndex=0; iIndex <= iLen; iIndex++) {
		if (iFound != 0) iFound = 0;
		for (iIndexB=0; iIndexB < iSubLen; iIndexB++) {
			if (tolower(string[iIndex + iIndexB]) == tolower(substr[iIndexB])) 
				iFound++;
			else break;
		}
		if (iFound == iSubLen)
			return string + iIndex;

	}

	return NULL;

}

//
//	Case compare of two strings
//
//
BOOL cstrstr( char * string, char * substr) {
	
	if ((strlen(string) - strlen(substr))  < 0)
		return FALSE; //substring is too big

	if (strstr(string, substr) != NULL)
		return TRUE;
	else 
		return FALSE;

}

BOOL LoadFileNames() {


	return FALSE;
}


char * getNextFile(int iVersion, int i) {
	char * filename;
	int iLen = 0;

	iLen += strlen(BIBLE_PATH);
	iLen +=	strlen(gBibles.getCharName(iVersion));
	iLen +=	strlen(BIBLE_TXT[i]);
	iLen +=	strlen(BIBLE_EXT);
	iLen +=	2;

	filename = new char[iLen];

	strcpy(filename, BIBLE_PATH);
	strcat(filename, gBibles.getCharName(iVersion));
	strcat(filename, BIBLE_TXT[i]);
	strcat(filename, BIBLE_EXT);
	//filename[strlen(NIV_FILE_PATH) + strlen(NIV[i])] = '\0';
	return filename;
}

//Try again
LRESULT DoSearch(HWND hWnd) {
	FILE *stream;
	char buffer[MAX_VERSETEXT];
//	TCHAR szText[MAX_VERSETEXT];
	int iIndex = 0;
	int iIndex2 = 0;
	int iResultMax = 0;
	int iFound = 0;
	int iLineNumber=0;
	int iOffset = 0;
	char * fName = NULL;
	int iPosition = 0;
	//int iSearchPos = 0;
	int iAbbrLen = 0;
	char * pszBuffer = NULL;
	int iItemPosition = 0;
	int iItemNum = 0;
	int iNumFound = 0;
	int iNumFoundAfter = 0;
	//int SearchNum = 0;
	//SIZE textSize;
	RECT rcl;
	int CharsDisplayed = 0;
	//int iRowNum = 0;
	int iLastResult = 0;
	int TotalCharsToDisplay = 0;
	int CharsThisItem = 0;
	int CharsThisItemLast = 0;
	int BooksWithNumbers = 0;
	int BufferOffset = 0;
	BOOL KeepLooking = FALSE;
	//int iResultsSoFar;
	HDC hdc;
	SIZE textSize;
	int iFirstTokenOffset;
	int ScreenWidth = 0;
	char * SearchStr;
	char * FoundStr;
//	char * szBeginText;
	int iVerseLen;
	int iChapter;
	int iVerse;
	char * szChapter;
	char * szVerse;
	HFONT hf_old; 
	

	bookNum bn(g_iWhichBooks);
	
	//DeleteObject(g_hfFont);

	hdc = GetDC(hWnd);	

	hf_old = (HFONT) SelectObject(hdc, g_hfFont);

	SendMessage(hWnd, WM_SETFONT, (WPARAM)g_hfFont, 0);

	//myWMSetFont(hWnd);
	//SelectObject(hdc, (HGDIOBJ) g_hfFont);
	//SelectObject(hdc, (HGDIOBJ) g_hfFont);

	LVITEM lvI;				// list view item structure

	lvI.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE;
	lvI.state = 0;      
	lvI.stateMask = 0;  


	//iSearchResultsNum = 0;

	ListView_DeleteAllItems(hWnd);

	UpdateWindow(hWnd);
	
	GetClientRect(hWnd, &rcl);
	

	ScreenWidth = rcl.right - rcl.left - BITMAP_WIDTH*2 - GetSystemMetrics( SM_CXVSCROLL );
	//wsprintf(szText, TEXT("Width: %d"), ScreenWidth);
	//MessageBox(hWnd, szText, TEXT("Error"), MB_OK | MB_ICONSTOP);


	//Clear Data Structure
	for (iIndex=0; iIndex < MAX_RESULTS; iIndex++) {
		if (gpszSearch[iIndex].alloc) {
			delete [] gpszSearch[iIndex].str;
		}
		ZeroMemory(&gpszSearch[iIndex], sizeof(SEARCHTYPE));
//		gpszSearch[iIndex].alloc = FALSE;
//		gpszSearch[iIndex].str = NULL;
//		gpszSearch[iIndex].len = 0;
	}

	//Open First Book
	if( (stream  = fopen( fName = getNextFile(g_iBibleVersion, bn.current()), "r" )) == NULL ) {
		MessageBox(hWnd, TEXT("The file was not opened"), TEXT("Error"), MB_OK | MB_ICONSTOP);
		return FALSE;
	}

	delete [] fName;
	
	//MultiByteToWideChar(0,0,fName, strlen(fName), buffer2, MAX_VERSETEXT);
	//MessageBox(hWnd, buffer2, TEXT("Error"), MB_OK | MB_ICONSTOP);
	//else MessageBox(hWnd, TEXT("The file 'data' was opened"), TEXT("Error"), MB_OK | MB_ICONSTOP);

	iItemPosition = 0;
	while( 1 ) {
		//iLineNumber++;

		if ((fgets( buffer, MAX_VERSETEXT, stream ) == NULL) && feof(stream)) {
			//No results and EOF
			fclose(stream);
			if (bn.next()) {
				//Open Next Book
				if( (stream  = fopen( fName = getNextFile(g_iBibleVersion, bn.current()), "r" )) == NULL ) {
					MessageBox(hWnd, TEXT("The file was not opened"), TEXT("Error"), MB_OK | MB_ICONSTOP);
					return FALSE;
				}
			} else {
				//Read all of the books
				
				//Fill out LVITEM structure for new List Item
				wsprintf(gszLastResults, TEXT("[END OF RESULTS: %d Found.]"), gPages.foundSum(gPages.totalPages())+iNumFoundAfter);

				gLastResults.str = gszLastResults;
				gLastResults.len = _tcslen(gszLastResults);
				gLastResults.alloc = FALSE; 

				lvI.iImage = 0;
				lvI.iItem = iItemPosition; //iSearchResultsNum;
				lvI.iSubItem = 0;
				lvI.pszText = LPSTR_TEXTCALLBACK; 
				lvI.cchTextMax = gLastResults.len + 1;
				lvI.lParam = (LPARAM) &gLastResults; //pointer to struct
			
				//Throw that baby on the pile
				if (ListView_InsertItem(hWnd, &lvI) == -1)
					return FALSE; //error
			
				//Setup call back (Call Back will add item to List)
				ListView_SetItemText( hWnd,	iItemPosition, 0, LPSTR_TEXTCALLBACK);
				ListView_SetColumnWidth(hWnd, 0, LVSCW_AUTOSIZE);
				break;
			}
		}

		if (ferror(stream)) {
			//Error
			MessageBox(hWnd, TEXT("Error Reading File"), TEXT("Error"), MB_OK | MB_ICONSTOP);
			break;
		}

		//iOffset = ;

		//gpszCharTokens[0]
		iFirstTokenOffset = strlen(buffer); // - CONCORDANCE_PREFACE;
		iFound = 0;
		SearchStr = buffer;

		//Remove number and :

		//convert chapter
		szChapter = SearchStr;
		while ((*SearchStr != ':')) {
			SearchStr++;
		}
		*SearchStr = NULL;
		iChapter = atoi(szChapter);
		*SearchStr = ':';
		SearchStr++;

		//Convert Verse
		szVerse = SearchStr;
		while (*SearchStr != ' ') 
			SearchStr++; //remove first space

		*SearchStr = NULL;
		iVerse = atoi(szVerse);
		*SearchStr = ' ';
		SearchStr++;

		iVerseLen = SearchStr - buffer;


		for (iIndex=0; iIndex < giTokens; iIndex++) {
			//user cstrstr(,) for case compare

			//caseless compare
			if (g_hwndMatchCase) {
				if ((FoundStr = strstr(SearchStr, gpszCharTokens[iIndex])) != NULL) {
					if ((FoundStr - SearchStr) < iFirstTokenOffset)
						iFirstTokenOffset = FoundStr - SearchStr;
					iFound++;
				} else break;
			} else {
				if ((FoundStr = ncstrstr(SearchStr, gpszCharTokens[iIndex])) != NULL) {
					if ((FoundStr - SearchStr) < iFirstTokenOffset)
						iFirstTokenOffset = FoundStr - SearchStr;
					iFound++;
				} else break;
			}

		}
	
		if (iFound == giTokens) {

			iNumFound++; //found a result

			if (iItemPosition >= MAX_RESULTS) {
				//Erase partially displayed verses
				if (CharsDisplayed < TotalCharsToDisplay) {
					for (iIndex=iLastResult; iIndex < iItemPosition; iIndex++) {
						ListView_DeleteItem(hWnd, iLastResult); 
					}
					iNumFoundAfter--;
				} 
				
				//Update Num Pages and Num of results for this page
				//wsprintf(szText, TEXT("results: sum: %d curr: %d numfound:%d"), gPages.foundSum(), gPages.getCurrent(), iNumFoundAfter);
				//MessageBox(hWnd, szText, TEXT("Error"), MB_OK | MB_ICONSTOP);

				if (gPages.currentIsEnd())
					gPages.addPage(iNumFoundAfter);

				break; //ALL DONE!
			}


			if (iNumFound <= gPages.foundSum()) {
				continue;
			}
			iNumFoundAfter++;

			gpszSearch[iItemPosition].len = strlen(buffer);
			
			if (buffer[gpszSearch[iItemPosition].len-1] == '\n') {
				buffer[gpszSearch[iItemPosition].len-1] = NULL;
				gpszSearch[iItemPosition].len--;
			}

			if (buffer[gpszSearch[iItemPosition].len-1] == '\r') {
				buffer[gpszSearch[iItemPosition].len-1] = NULL;
				gpszSearch[iItemPosition].len--;
			}

			
			lvI.iImage = 0; //cross icon

			iAbbrLen = strlen(ABBR[bn.current()]); //Book Name Length 

			//Allocate space for List Item, extra 1 for null.
			gpszSearch[iItemPosition].len = iAbbrLen + strlen(buffer);
			gpszSearch[iItemPosition].str = new TCHAR[gpszSearch[iItemPosition].len + 2]; //plus extra dummy byte (crashes without it)
			gpszSearch[iItemPosition].alloc = TRUE;
			gpszSearch[iItemPosition].version = g_iBibleVersion;
			gpszSearch[iItemPosition].book = bn.current();
			gpszSearch[iItemPosition].chapter = iChapter - 1;
			gpszSearch[iItemPosition].verse = iVerse;

			MultiByteToWideChar(0,0,ABBR[bn.current()], iAbbrLen, gpszSearch[iItemPosition].str, iAbbrLen);

			//Copy char to TCHAR
			MultiByteToWideChar(0,0,buffer, strlen(buffer), gpszSearch[iItemPosition].str + iAbbrLen, strlen(buffer));
			gpszSearch[iItemPosition].str[gpszSearch[iItemPosition].len] = '\0'; //ensure NULL terminated

			iLastResult = iItemPosition; //last memory allocation
			TotalCharsToDisplay = gpszSearch[iLastResult].len; 

			if (g_bConcordanceView) {
				/* ************************************* 
				*
				*   This section will break up the verse
				*	So that it is in concordance view.
				*
				 ************************************* */

				//To make sure first token is on the screen,
				//dont display more than 10 chars before firsts
				//token.
				if ((iFirstTokenOffset > CONCORDANCE_PREFACE) && (CONCORDANCE_PREFACE > 2)) {
					gpszSearch[iItemPosition].len -= (iFirstTokenOffset - CONCORDANCE_PREFACE);
					for (iIndex=iAbbrLen+iVerseLen+1; iIndex < gpszSearch[iItemPosition].len; iIndex++) {
						gpszSearch[iItemPosition].str[iIndex] = gpszSearch[iItemPosition].str[iIndex + (iFirstTokenOffset - CONCORDANCE_PREFACE)];
					}
					gpszSearch[iItemPosition].str[iAbbrLen+iVerseLen] = '.';
					gpszSearch[iItemPosition].str[iAbbrLen+iVerseLen+1] = '.';
					gpszSearch[iItemPosition].str[gpszSearch[iItemPosition].len] = NULL;
				}
				//iFirstTokenOffset
				//iVerseLen
				//iAbbrLen

				//New Item
				CharsThisItem = 0; //Number that fits
				CharsThisItemLast = 0; //Last value that fit
				
				while (CharsThisItem++ < TotalCharsToDisplay) {
					if (gpszSearch[iItemPosition].str[CharsThisItem-1] == ' ') {//search for space

						//Test for too wide
						GetTextExtentPoint32(hdc, gpszSearch[iItemPosition].str, CharsThisItem, &textSize );
						if (textSize.cx > ScreenWidth) {
							//Fits!!
							break;
						} 
						//Store Last Fitting value
						CharsThisItemLast = CharsThisItem-1; //remove space
					} 
				}

				GetTextExtentPoint32(hdc, gpszSearch[iItemPosition].str, CharsThisItem, &textSize );
				if ((CharsThisItem >= TotalCharsToDisplay) && (textSize.cx <= ScreenWidth)) 
					CharsThisItemLast = CharsThisItem; //remove space

				GetTextExtentPoint32(hdc, gpszSearch[iItemPosition].str, CharsThisItemLast, &textSize );


				gpszSearch[iItemPosition].str[CharsThisItemLast] = '\0';
				TotalCharsToDisplay -= CharsThisItemLast + 1; // count NULL
				gpszSearch[iItemPosition].len = _tcslen(gpszSearch[iItemPosition].str);
				
							
				//Fill out LVITEM structure for new List Item
				lvI.iItem = iItemPosition; //iSearchResultsNum;
				lvI.iSubItem = 0;
				lvI.pszText = LPSTR_TEXTCALLBACK; 
				lvI.cchTextMax = gpszSearch[iItemPosition].len;
				lvI.lParam = (LPARAM) &gpszSearch[iItemPosition]; //pointer to struct
			
				if (ListView_InsertItem(hWnd, &lvI) == -1)
					return FALSE; //error
			
				//Setup call back (Call Back will add item to List)
				ListView_SetItemText( hWnd,	iItemPosition, 0, LPSTR_TEXTCALLBACK);
				ListView_SetColumnWidth(hWnd, 0, LVSCW_AUTOSIZE);
				//lvI.mask &= ~LVIF_IMAGE;
				iItemPosition++;
				UpdateWindow(hWnd);
				if (lvI.iImage == 0) 
					lvI.iImage = 1;
				
				//if (iItemPosition >= MAX_RESULTS) continue;
				
			
			} else {

				/* ************************************* 
				*
				*   This section will break up the verse
				*	and wrap the verse to prevent horiz.
				*	scrolling.
				*
				 ************************************* */


				while (TotalCharsToDisplay > 0) { //includes final NULL

					//New Item
					CharsThisItem = 0; //Number that fits
					CharsThisItemLast = 0; //Last value that fit
					
					//Set Head of String
					if (iItemPosition != iLastResult) { //not first item for verse
						gpszSearch[iItemPosition].str = gpszSearch[iItemPosition-1].str + (gpszSearch[iItemPosition-1].len + 1); //skip null
					}
					while (CharsThisItem++ < TotalCharsToDisplay) {
						if (gpszSearch[iItemPosition].str[CharsThisItem-1] == ' ') {//search for space

							//Test for too wide
							GetTextExtentPoint32(hdc, gpszSearch[iItemPosition].str, CharsThisItem, &textSize );
							if (textSize.cx > ScreenWidth) {
								//Fits!!
								break;
							} 
							//Store Last Fitting value
							CharsThisItemLast = CharsThisItem-1; //remove space
						} 
					}

					GetTextExtentPoint32(hdc, gpszSearch[iItemPosition].str, CharsThisItem, &textSize );
					if ((CharsThisItem >= TotalCharsToDisplay) && (textSize.cx <= ScreenWidth)) 
						CharsThisItemLast = CharsThisItem; //remove space

					GetTextExtentPoint32(hdc, gpszSearch[iItemPosition].str, CharsThisItemLast, &textSize );


					gpszSearch[iItemPosition].str[CharsThisItemLast] = '\0';
					TotalCharsToDisplay -= CharsThisItemLast + 1; // count NULL
					gpszSearch[iItemPosition].len = _tcslen(gpszSearch[iItemPosition].str);
					
								
					//Fill out LVITEM structure for new List Item
					lvI.iItem = iItemPosition; //iSearchResultsNum;
					lvI.iSubItem = 0;
					lvI.pszText = LPSTR_TEXTCALLBACK; 
					lvI.cchTextMax = gpszSearch[iItemPosition].len;
					lvI.lParam = (LPARAM) &gpszSearch[iItemPosition]; //pointer to struct
				
					if (ListView_InsertItem(hWnd, &lvI) == -1)
						return FALSE; //error
				
					//Setup call back (Call Back will add item to List)
					ListView_SetItemText( hWnd,	iItemPosition, 0, LPSTR_TEXTCALLBACK);
					ListView_SetColumnWidth(hWnd, 0, LVSCW_AUTOSIZE);
					//lvI.mask &= ~LVIF_IMAGE;
					iItemPosition++;
					UpdateWindow(hWnd);
					if (lvI.iImage == 0) 
						lvI.iImage = 1;
					
					if (iItemPosition >= MAX_RESULTS) break;
					
				}
			}
		}
	}

	SelectObject(hdc, hf_old);
	ReleaseDC(hWnd, hdc);

	_fcloseall(); //make sure all files are closed
	return TRUE;
}


	
	
//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	//HDC hdc;
	int wmId, wmEvent;
	//PAINTSTRUCT ps;
	TCHAR szTemp[1000];
	static HWND hWndListView;
	static HWND hWndListBox;
	static HWND hWndEditControl;
	//DRAWITEMSTRUCT * lpOwner = (DRAWITEMSTRUCT *) lParam;
	LPDRAWITEMSTRUCT lpOwner = (LPDRAWITEMSTRUCT)lParam;
    LPMEASUREITEMSTRUCT lpmis; 
	//HWND WelcomeDialog;
	int iPageNum = 0;
	HFONT hFont=0;
//	LOGFONT logFont;
//	HDC hdcListView;
//	HDC hdc;


	//BOOL bDoSearch = FALSE;

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId) {	
				case IDM_TOOLS_GOTOVERSE:
					DialogBox(g_hInst, (LPCTSTR)IDD_VERSEBOX, hWnd, (DLGPROC)VerseBox);
				    break;
				case IDM_HELP_ABOUT:
					DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				    break;
				case IDM_MENU_SEARCH:
					gbSearch = FALSE;
					DialogBox(g_hInst, (LPCTSTR)IDD_SEARCHBOX, hWnd, (DLGPROC)SearchBox);
					//gSearchPageNum = 0;
					//gSearchPageNumMax = 0;
					gPages.clearPages();
					SendMessage (hWnd, WM_USER, ID_DO_SEARCH, 0);
				    break;
				case IDM_WHBBIBLE_NEXT:
					//gSearchPageNum++;
					if (gPages.currentNext())
						SendMessage (hWnd, WM_USER, ID_DO_SEARCH, 0);
					break;
				
				case IDM_WHBBIBLE_PREV:
					//gSearchPageNum--;
					if (gPages.currentPrev())
						SendMessage (hWnd, WM_USER, ID_DO_SEARCH, 0);
					break;
				
				case IDOK:
					SendMessage(hWnd, WM_ACTIVATE, MAKEWPARAM(WA_INACTIVE, 0), (LPARAM)hWnd);
					SendMessage (hWnd, WM_CLOSE, 0, 0);
					break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;

		case ID_MENU_COPY:
			//giLastSelectedItem
			MessageBox (NULL, TEXT("ID_MENU_COPY"), NULL, MB_OK );
			break;

		case WM_MEASUREITEM: 
			MessageBox (NULL, TEXT("WM_MEASUREITEM"), NULL, MB_OK );

			lpmis = (LPMEASUREITEMSTRUCT) lParam; 
 
            // Set the height of the list box items. 
			lpmis->itemHeight = 20; 
            return TRUE; 

			break;

		case WM_DRAWITEM:
			//ODT_LISTVIEW == lpOwner->CtlType

			wsprintf(szTemp, TEXT("ct: %d cid: %d iid: %d iac: %d is: %d \nrcitem: top:%u bot:%u lef:%u rig:%u id: %u"),
				lpOwner->CtlType,
				lpOwner->CtlID,
				lpOwner->itemID,
				lpOwner->itemAction,
				lpOwner->itemState,
				lpOwner->rcItem.top,
				lpOwner->rcItem.bottom,
				lpOwner->rcItem.left,
				lpOwner->rcItem.right,
				lpOwner->itemData
			);


			//wsprintf(szTemp, TEXT("ct: %d cid: %d iid: %d iac: %d is: %d \nrcitem: top-%d bot-%d lef-%d rig-%d id: %d"),lpOwner->CtlType,lpOwner->CtlID,lpOwner->itemID,lpOwner->itemAction,lpOwner->itemState,	lpOwner->hwndItem,	lpOwner->hDC,lpOwner->rcItem.top, lpOwner->rcItem.bottom,lpOwner->rcItem.left,	lpOwner->rcItem.right,	lpOwner->itemData	);

			//MessageBox (NULL, szTemp, NULL, MB_OK );
			break;

		case WM_CREATE:

			
			g_hwndCB = CreateRpCommandBar(hWnd);
			//if (!EnableMenuItem(LoadMenu(g_hInst, MAKEINTRESOURCE(IDM_MENU)), IDM_COPY, MF_GRAYED | MF_BYCOMMAND )) {
			//	MessageBox (NULL, TEXT("Didnt work!"), NULL, MB_OK );
			//}

            // Initialize the shell activate info structure
            memset (&s_sai, 0, sizeof (s_sai));
            s_sai.cbSize = sizeof (s_sai);

			myWMSetFont(hWnd);

			//setFont(hWnd);
			hWndListView = CreateListView( hWnd);
			if (hWndListView == NULL)
				MessageBox (NULL, TEXT("Listview not created!"), NULL, MB_OK );
			

			//FILE_ATTRIBUTE_DIRECTORY
			//LoadBibles();

			DialogBox(g_hInst, (LPCTSTR)IDD_WELCOME, hWnd, (DLGPROC)WelcomeBox);

			if (gBibles.getNum() == 0) {
				MessageBox (NULL, TEXT("No Bibles Installed!\nPlease visit WHB for bibles:\nwww.havenofbliss.com"), NULL, MB_ICONSTOP|MB_OK );
				SendMessage(hWnd, WM_DESTROY, 0, 0);
			}


			break;

			
		case WM_NOTIFY:
			return( NotifyHandler(hWnd, message, wParam, lParam));
			break;

		case WM_USER:
			wmId    = LOWORD(wParam); 


		
			switch (wParam) {
				case ID_DO_SEARCH:
					if (hWndListView == NULL) {
						MessageBox (NULL, TEXT("Listview not created!"), NULL, MB_OK );
						break;
					}
					if (gbSearch) {
						DoSearch(hWndListView);
					}
					break;

				case ID_READ_CHAPTER:
					DialogBox(g_hInst, (LPCTSTR)IDD_CHAPTERBOX, hWnd, (DLGPROC)ChapterBox);
					break;

				default:

					break;
			}
			break;
				
		case WM_SIZE:
            MoveWindow(hWndListView, 0, 0, LOWORD(lParam),HIWORD(lParam),TRUE);
            break;

		case WM_DESTROY:
			CommandBar_Destroy(g_hwndCB);
			PostQuitMessage(0);
			break;
		case WM_ACTIVATE:
            // Notify shell of our activate message
			SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
     		break;
		case WM_SETTINGCHANGE:
			SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
     		break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

HWND CreateChapterCommandBar(HWND hwnd)
{
	SHMENUBARINFO mbi;

	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = IDM_MENU;
	mbi.hInstRes   = g_hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;

	if (!SHCreateMenuBar(&mbi)) 
		return NULL;

	CommandBar_AddBitmap (mbi.hwndMB, g_hInst, IDB_LEFTARROW, IDB_STD_SMALL_COLOR, 16, 16);
	CommandBar_AddBitmap (mbi.hwndMB, g_hInst, IDB_RIGHTARROW, IDB_STD_SMALL_COLOR, 16, 16);
	return mbi.hwndMB;
}



HWND CreateRpCommandBar(HWND hwnd)
{
	SHMENUBARINFO mbi;

	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = IDM_MAINMENU;
	mbi.hInstRes   = g_hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;

	if (!SHCreateMenuBar(&mbi)) 
		return NULL;

	CommandBar_AddBitmap (mbi.hwndMB, g_hInst, IDB_LEFTARROW, IDB_STD_SMALL_COLOR, 16, 16);
	CommandBar_AddBitmap (mbi.hwndMB, g_hInst, IDB_RIGHTARROW, IDB_STD_SMALL_COLOR, 16, 16);

	//EnableMenuItem(LoadMenu(g_hInst, MAKEINTRESOURCE(IDM_MENU)), IDM_COPY, MF_GRAYED | MF_BYCOMMAND )


	return mbi.hwndMB;
}

// Mesage handler for the About box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;

	switch (message)
	{
		case WM_INITDIALOG:
			// Create a Done button and size it.  
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
			return TRUE; 

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK)
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

BOOL ExactMatchToken(HWND hDlg) {
	for (int i=0; i<NUM_TOKENS; i++) {
		gpszTokens[i] = NULL; //set ptr to null
		gpszCharTokens[i] = NULL; //set char ptr to null
		giTokensLen[i] = 0; //reset length
	}

	
	gpszTokens[0] = gszTokenString; 
	gpszCharTokens[0] = gszCharTokenString; //set char ptr to null
	giTokensLen[0] = _tcslen(gszTokenString); //reset length
	giTokens = 1;

	_tcscpy(gszOriginalTokenString, gszTokenString);
	WideCharToMultiByte(0,0, gszTokenString, giTokensLen[0], gpszCharTokens[0], giTokensLen[0], NULL, NULL);
	gszCharTokenString[giTokensLen[0]] = NULL;

	return TRUE;

}


//Return False if No results are found.
//Clear Old Search String, and 
//fill new one in.
//
BOOL ParseTokens(HWND hDlg) {
	//Clear Old String
	TCHAR * pszTokenizer = NULL;
	TCHAR TOKENS[] = TEXT(" ,\t\n");
	char * CharPtr = NULL;
	int iRemain = MAX_TOKENSTR;

	//TCHAR szTemp [100];
	int iLen = 0;

	for (int i=0; i<NUM_TOKENS; i++) {
		gpszTokens[i] = NULL; //set ptr to null
		gpszCharTokens[i] = NULL; //set char ptr to null
		giTokensLen[i] = 0; //reset length
	}

//	memset(&giTokensLen, 0, sizeof(giTokensLen));

	_tcscpy(gszOriginalTokenString, gszTokenString);

	giTokens = 0; //redundant
	CharPtr = gszCharTokenString;
   // Establish string and get the first token: 
	pszTokenizer = _tcstok( gszTokenString, TOKENS );
	while (pszTokenizer != NULL) {
		iLen = _tcslen(pszTokenizer); //figure out length of token
		gpszTokens[giTokens] = pszTokenizer; 
		//memset(gpszTokens[giTokens], 0, iLen); //clear new memory
		//_tcscpy(gpszTokens[giTokens], pszTokenizer); //copy new token
		gpszTokens[giTokens][iLen] = '\0'; //redundant
		giTokensLen[giTokens] = iLen;

		//Create Tokens in char type
		WideCharToMultiByte(0,0, pszTokenizer, iLen, CharPtr, iRemain, NULL, NULL);
		gpszCharTokens[giTokens] = CharPtr; 
		gpszCharTokens[giTokens][iLen] = '\0'; //redundant
		CharPtr += iLen + 1;
		iRemain -= (iLen + 1);


		//Following are debug statements
		//
		//	MessageBox(hDlg, gpszTokens[giTokens], TEXT("tokens"), MB_OK | MB_ICONSTOP);
		//	wsprintf(szTemp, TEXT("%d %s"), iLen, gpszTokens[giTokens]);
		//	MessageBox(hDlg, szTemp, TEXT("tokens"), MB_OK | MB_ICONSTOP);
		//

		giTokens++;
		pszTokenizer = _tcstok( NULL, TOKENS );

	}
		
	return TRUE;
}


// Mesage handler for the Search box.
LRESULT CALLBACK SearchBox(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;
	HWND hwndSelectBooks;
	HWND hwndConcordance;
	HWND hwndMatchCase;
	HWND hwndExactMatch;
	//g_hwndExactMatch
	HWND hWndVersion;
	int iIndex;
	//HWND EditBox;
	//TCHAR*	pszSearch;
	//int		iIndex;

	//gbSearch = FALSE;

	switch (message)
	{
		case WM_INITDIALOG:
			// Create a Done button and size it.  
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hDlg;

			SetFocus(GetDlgItem(hDlg, IDC_SEARCH_BOX));
			//CheckRadioButton(hDlg, IDC_FULLVERSE, IDC_CONCORDANCE, IDC_FULLVERSE ); 

			hwndSelectBooks = GetDlgItem(hDlg, IDC_SELECTBOOKS);

			SendMessage(hwndSelectBooks, CB_ADDSTRING, 0, (LPARAM)SEARCH_BOOKS[0]); 
			SendMessage(hwndSelectBooks, CB_ADDSTRING, 0, (LPARAM)SEARCH_BOOKS[1]); 
			SendMessage(hwndSelectBooks, CB_ADDSTRING, 0, (LPARAM)SEARCH_BOOKS[2]); 
			SendMessage(hwndSelectBooks, CB_ADDSTRING, 0, (LPARAM)SEARCH_BOOKS[3]); 
			SendMessage(hwndSelectBooks, CB_ADDSTRING, 0, (LPARAM)SEARCH_BOOKS[4]); 


			SendMessage(hwndSelectBooks, CB_SETCURSEL, g_iWhichBooks, 0); 

			hwndConcordance = GetDlgItem(hDlg, IDC_CONCORDANCE);
			if (g_bConcordanceView)
				SendMessage(hwndConcordance, BM_SETCHECK, BST_CHECKED, 0);
			else SendMessage(hwndConcordance, BM_SETCHECK, BST_UNCHECKED, 0);

			hwndMatchCase = GetDlgItem(hDlg, IDC_MATCHCASE);
			if (g_hwndMatchCase)
				SendMessage(hwndMatchCase, BM_SETCHECK, BST_CHECKED, 0);
			else SendMessage(hwndMatchCase, BM_SETCHECK, BST_UNCHECKED, 0);

			hwndExactMatch = GetDlgItem(hDlg, IDC_EXACTMATCH);
			if (g_hwndExactMatch)
				SendMessage(hwndExactMatch, BM_SETCHECK, BST_CHECKED, 0);
			else SendMessage(hwndExactMatch, BM_SETCHECK, BST_UNCHECKED, 0);


			
			hWndVersion = GetDlgItem(hDlg, IDC_VERSION);
//			SendMessage(hWndVersion, CB_ADDSTRING, 0, (LPARAM)VERSION[0]); //NIV
//			SendMessage(hWndVersion, CB_ADDSTRING, 0, (LPARAM)VERSION[1]); //KJV
//			SendMessage(hWndVersion, CB_ADDSTRING, 0, (LPARAM)VERSION[2]); //NASB
//			SendMessage(hWndVersion, CB_ADDSTRING, 0, (LPARAM)VERSION[3]); //NKJV

			for (iIndex=0; iIndex<gBibles.getNum(); iIndex++) {
				SendMessage(hWndVersion, CB_ADDSTRING, 0, (LPARAM) gBibles.getName(iIndex)); //NKJV
			}


			SendMessage(hWndVersion, CB_SETCURSEL, g_iBibleVersion, 0); 

			//SendMessage(hWndBook, CB_SETCURSEL, 1, 0); 


			if (gszTokenString) 
				SetDlgItemText(hDlg, IDC_SEARCH_BOX, gszOriginalTokenString);

			SHInitDialog(&shidi);
			break;


		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK)
			{
				EndDialog(hDlg, LOWORD(wParam));
				return FALSE;
			}
			if (LOWORD(wParam) == IDSEARCH)
			{
				//pszSearch = (TCHAR*)malloc(MAX_VERSETEXT);
				memset(gszTokenString, 0, MAX_TOKENSTR);
				GetDlgItemText(hDlg, IDC_SEARCH_BOX, gszTokenString, MAX_VERSETEXT);
				//EndDialog(hDlg, LOWORD(wParam));
				if(_tcslen(gszTokenString) == 0)	{
					MessageBox(hDlg, TEXT("Please enter a Search String"), TEXT("Add Entry Problem"), MB_OK | MB_ICONSTOP);
					break;
				} 

				hwndSelectBooks = GetDlgItem(hDlg, IDC_SELECTBOOKS);
				g_iWhichBooks = SendMessage(hwndSelectBooks, CB_GETCURSEL, 0, 0); 

				hWndVersion = GetDlgItem(hDlg, IDC_VERSION);
				g_iBibleVersion = SendMessage(hWndVersion, CB_GETCURSEL, 0, 0); 

				hwndConcordance = GetDlgItem(hDlg, IDC_CONCORDANCE);
				g_bConcordanceView = (SendMessage(hwndConcordance, BM_GETCHECK, 0, 0)==BST_CHECKED); //?TRUE:FALSE;

				hwndMatchCase = GetDlgItem(hDlg, IDC_MATCHCASE);
				g_hwndMatchCase = (SendMessage(hwndMatchCase, BM_GETCHECK, 0, 0)==BST_CHECKED); //?TRUE:FALSE;

				hwndExactMatch = GetDlgItem(hDlg, IDC_EXACTMATCH);
				g_hwndExactMatch = (SendMessage(hwndExactMatch, BM_GETCHECK, 0, 0)==BST_CHECKED); //?TRUE:FALSE;

				//figure out Search Tokens
				if (g_hwndExactMatch)
					ExactMatchToken(hDlg);
				else 
					ParseTokens(hDlg);

				gbSearch = TRUE;


				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}


			if (LOWORD(wParam) == CBN_SELENDOK) {
					MessageBox(hDlg, TEXT("CBN_SELENDOK"), TEXT("Error"), MB_OK | MB_ICONSTOP);

			}
			if (LOWORD(wParam) == CBN_SELCHANGE) {
				// CB_GETCURSEL 
					MessageBox(hDlg, TEXT("CBN_SELCHANGE"), TEXT("Error"), MB_OK | MB_ICONSTOP);

			}
			break;

		case WM_NOTIFY:
				MessageBox(hDlg, TEXT("WM_NOTIFY"), TEXT("Error"), MB_OK | MB_ICONSTOP);

			
			
			break;

	}
    return FALSE;
}



// Mesage handler for the Welcome box.
LRESULT CALLBACK VerseBox(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;
	int iIndex;
	HWND hWndVersion;
	HWND hWndBook;
	HWND hWndChapter;
	TCHAR szChapter[5];
	//HWND hWndParent;

	int wmId;
	int wmEvent;

	switch (message)
	{
		case WM_INITDIALOG:
			// Create a Done button and size it.  
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hDlg;

			//SetFocus(GetDlgItem(hDlg, IDC_SEARCH_BOX));
			hWndVersion = GetDlgItem(hDlg, IDC_WHICHVERSION);
			hWndBook = GetDlgItem(hDlg, IDC_WHICHBOOK);
			hWndChapter = GetDlgItem(hDlg, IDC_WHICHCHAPTER);

//			SendMessage(hWndVersion, CB_ADDSTRING, 0, (LPARAM)VERSION[0]); //NIV
//			SendMessage(hWndVersion, CB_ADDSTRING, 0, (LPARAM)VERSION[1]); //KJV
//			SendMessage(hWndVersion, CB_ADDSTRING, 0, (LPARAM)VERSION[2]); //NASB
//			SendMessage(hWndVersion, CB_ADDSTRING, 0, (LPARAM)VERSION[3]); //NKJV

			for (iIndex=0; iIndex<gBibles.getNum(); iIndex++) {
				SendMessage(hWndVersion, CB_ADDSTRING, 0, (LPARAM) gBibles.getName(iIndex)); //NKJV
			}

			
			for (iIndex=0; iIndex<BOOKS_IN_BIBLE; iIndex++)
				SendMessage(hWndBook, CB_ADDSTRING, 0, (LPARAM)BOOK_NAME[iIndex]);
	
			for (iIndex=1; iIndex<=CHAPTERS[g_ChapterDisplay.iBook]; iIndex++) {
				wsprintf(szChapter, TEXT("%d"), iIndex);
				SendMessage(hWndChapter, CB_ADDSTRING, 0, (LPARAM)szChapter);
			}
			if (g_ChapterDisplay.iChapter >= CHAPTERS[g_ChapterDisplay.iBook]) 
				g_ChapterDisplay.iChapter = 0;
			
			SendMessage(hWndVersion, CB_SETCURSEL, g_ChapterDisplay.iVersion, 0); 
			SendMessage(hWndBook, CB_SETCURSEL, g_ChapterDisplay.iBook, 0); 
			SendMessage(hWndChapter, CB_SETCURSEL, g_ChapterDisplay.iChapter, 0); 

			SHInitDialog(&shidi);

			break;

		case WM_COMMAND:
			wmId = LOWORD(wParam);
			wmEvent = HIWORD(wParam); 
			switch (wmId) {
				case IDOK:
					EndDialog(hDlg, wmId);
					break;
				case ID_GOTO:

					hWndVersion = GetDlgItem(hDlg, IDC_WHICHVERSION);
					g_ChapterDisplay.iVersion = SendMessage(hWndVersion, CB_GETCURSEL, 0, 0); 

					hWndBook = GetDlgItem(hDlg, IDC_WHICHBOOK);
					g_ChapterDisplay.iBook = SendMessage(hWndBook, CB_GETCURSEL, 0, 0); 

					hWndChapter = GetDlgItem(hDlg, IDC_WHICHCHAPTER);
					g_ChapterDisplay.iChapter = SendMessage(hWndChapter, CB_GETCURSEL, 0, 0); 

					//hWndVerse = GetDlgItem(hDlg, IDC_VERSE);
					//g_ChapterDisplay.iVerse = SendMessage(hWndVerse, CB_GETCURSEL, 0, 0); 
					DialogBox(g_hInst, (LPCTSTR)IDD_CHAPTERBOX, GetParent(hDlg), (DLGPROC)ChapterBox);
					//SendMessage (GetParent(hDlg), WM_USER, ID_READ_CHAPTER, 0);
					EndDialog(hDlg, wmId);
					break;
			}

			switch (wmEvent) {
				case CBN_SELCHANGE:
					switch (wmId) {
						case IDC_WHICHBOOK:
							//MessageBox(hDlg, TEXT("CBN_SELCHANGE"), TEXT("Error"), MB_OK | MB_ICONSTOP);
							hWndBook = GetDlgItem(hDlg, IDC_WHICHBOOK);
							g_ChapterDisplay.iBook = SendMessage(hWndBook, CB_GETCURSEL, 0, 0); 

							
							hWndChapter = GetDlgItem(hDlg, IDC_WHICHCHAPTER);
							SendMessage(hWndChapter, CB_RESETCONTENT, 0, 0);  //clear old values

							for (iIndex=1; iIndex<=CHAPTERS[g_ChapterDisplay.iBook]; iIndex++) {
								wsprintf(szChapter, TEXT("%d"), iIndex);
								SendMessage(hWndChapter, CB_ADDSTRING, 0, (LPARAM)szChapter);
							}
							if (g_ChapterDisplay.iChapter >= CHAPTERS[g_ChapterDisplay.iBook]) 
								g_ChapterDisplay.iChapter = 0;
							
							SendMessage(hWndChapter, CB_SETCURSEL, g_ChapterDisplay.iChapter, 0); 
							break;
						case IDC_WHICHCHAPTER:
							hWndChapter = GetDlgItem(hDlg, IDC_WHICHCHAPTER);
							g_ChapterDisplay.iChapter = SendMessage(hWndChapter, CB_GETCURSEL, 0, 0); 
							break;
						default:
							break;
						
					}
					break;


				default:
					break;
			}

			break;


		case WM_CLOSE:
			//Sleep(WELCOME_SLEEP);
			//EndDialog(hDlg, LOWORD(wParam));
			break;
	
	
	}
	return FALSE;

}



// Mesage handler for the Welcome box.
LRESULT CALLBACK WelcomeBox(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{


	switch (message)
	{

		case WM_INITDIALOG:

			//SendMessage (hDlg, WM_CLOSE, 0, 0);
			break;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK)
			{
				EndDialog(hDlg, LOWORD(wParam));
			}
			break;

		case WM_CLOSE:
			//Sleep(WELCOME_SLEEP);
			//EndDialog(hDlg, LOWORD(wParam));
			break;
	
	
	}
	return FALSE;

}


bool SetChapterText() {
	FILE * stream;
	char * fName;	
	int iIndex;
	char szChapterNum[5];
	char buffer[MAX_VERSETEXT];
//	TCHAR szText[MAX_VERSETEXT];
	int iBufferSize=0;
	char * bufferTemp;
	//static TCHAR * pszChapter = NULL;
	static TCHAR * pszChapterTemp = NULL;
	static TCHAR * pszChapterSet = NULL;

	BOOL flag1;
	BOOL flag2;


	//Open First Book
	if( (stream  = fopen( fName = getNextFile(g_ChapterDisplay.iVersion, g_ChapterDisplay.iBook), "r" )) == NULL ) {
		//MessageBox(hDlg, TEXT("The file was not opened"), TEXT("Error"), MB_OK | MB_ICONSTOP);
		return FALSE;
	}

	sprintf(szChapterNum, "%d:", g_ChapterDisplay.iChapter+1);
//			if (g_ChapterDisplay.iChapter+1 == 3)
//				MessageBox(hDlg, L"3", TEXT("Error"), MB_OK | MB_ICONSTOP);

	//MessageBox(hDlg, szChapter, TEXT("Error"), MB_OK | MB_ICONSTOP);
	flag2 = FALSE;
	while (fgets( buffer, MAX_VERSETEXT, stream ) != NULL) {
		flag1 = TRUE;
		for (iIndex=0; iIndex<strlen(szChapterNum); iIndex++)
			if (buffer[iIndex] != szChapterNum[iIndex]) {
				flag1 = FALSE;
				break;
			}
		if (!flag1 && flag2) //found all values
			break;
		if (flag1) {
			iBufferSize += strlen(buffer) + 2;
			//iBufferSize += 1; //add extra space
			flag2 = TRUE;
		}
	}

	fseek( stream, 0L, SEEK_SET);
	if (gpszChapterText) 
		delete [] gpszChapterText;
	gpszChapterText = new TCHAR[iBufferSize + HEADER_LEN];
	wsprintf(gpszChapterText, TEXT("%s %s %d\r\n\r\n\0"), gBibles.getName(g_ChapterDisplay.iVersion), BOOK_NAME[g_ChapterDisplay.iBook], g_ChapterDisplay.iChapter+1);
	pszChapterTemp = gpszChapterText + _tcslen(gpszChapterText);
	//pszChapterTemp = gpszChapterText;

	flag2 = FALSE;
	while (fgets( buffer, MAX_VERSETEXT, stream ) != NULL) {
		flag1 = TRUE;
		//buffer[strlen(buffer)] = ' ';
		//buffer[strlen(buffer)+1] = NULL;
		for (iIndex=0; iIndex<strlen(szChapterNum); iIndex++)
			if (buffer[iIndex] != szChapterNum[iIndex]) {
				flag1 = FALSE;
				break;
			}
		if (!flag1 && flag2) //found all values
			break;
		if (flag1) {
			bufferTemp = buffer + strlen(szChapterNum);
			MultiByteToWideChar(0,0,bufferTemp, strlen(bufferTemp), pszChapterTemp, strlen(bufferTemp));
			pszChapterTemp += strlen(bufferTemp) - 1;
			flag2 = TRUE;
		}

	}
	*pszChapterTemp = NULL;


	//MessageBox(hDlg, gpszChapterText, TEXT("Error"), MB_OK | MB_ICONSTOP);
//			hWndEditBox = GetDlgItem(hDlg, ID_CHAPTER_TEXT);
//			SetWindowText(hWndEditBox, gpszChapterText);
//	SetDlgItemText(hDlg, ID_CHAPTER_TEXT, gpszChapterText);

	fclose(fName);

	delete [] fName;

	return true;
}


// Mesage handler for the About box.
LRESULT CALLBACK ChapterBox(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;

	static HWND hWndEditBox;
	static HWND hWndMenuBar;
//	HWND hWndDrawWindow;
//	HWND hWndVersion;
//	HWND hWndBook;
//	HWND hWndChapter;
	HDC	hdc;
	static int iPageSize = 0;
	static int iWindowSize = 0;
	static ScrollPosition = 0;
	//HBRUSH g_hbrBackground = CreateSolidBrush(RGB(255, 255, 255));
	//PAINTSTRUCT ps;
//	RECT  rcClient;
	static RECT  rcSize;
//	HBRUSH      hBrush ;
//	HDC         hdc ;
//	PAINTSTRUCT ps ;
//	SCROLLINFO si; 
	HFONT hf_old; 
	int wmId, wmEvent;

//	int ScrollTemp;
//	int iPageRemainer;




	//

	switch (message)
	{
		case WM_CTLCOLORDLG:
			MessageBox(hDlg, TEXT("WM_CTLCOLORDLG"), TEXT("Error"), MB_OK | MB_ICONSTOP);
			break;

		case WM_CTLCOLORSTATIC:
			MessageBox(hDlg, TEXT("WM_CTLCOLORSTATIC"), TEXT("Error"), MB_OK | MB_ICONSTOP);
			break;

		case WM_CTLCOLOREDIT:
			MessageBox(hDlg, TEXT("WM_CTLCOLOREDIT"), TEXT("Error"), MB_OK | MB_ICONSTOP);
			break;

		case WM_INITDIALOG:
			// Create a Done button and size it.  
			//MessageBox(hDlg, TEXT("WM_INITDIALOG"), TEXT("Error"), MB_OK | MB_ICONSTOP);
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);

			hWndEditBox = CreateEditBox(hDlg);
			
			hWndMenuBar = CreateChapterCommandBar(hDlg);

			SetChapterText();
			SetDlgItemText(hDlg, ID_CHAPTER_TEXT, gpszChapterText);

			hdc = GetDC(hWndEditBox);	
			hf_old = (HFONT) SelectObject(hdc, g_hfFont);
			SendMessage(hWndEditBox, WM_SETFONT, (WPARAM)g_hfFont, 0);
			SetBkColor(hdc, RGB(255, 255, 255));

			ReleaseDC(hWndEditBox, hdc);



			break;


		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId) {	
				case IDM_TOOLS_GOTOVERSE:
					EndDialog(hDlg, LOWORD(wParam));
					DialogBox(g_hInst, (LPCTSTR)IDD_VERSEBOX, GetParent(hDlg), (DLGPROC)VerseBox);
					//DestroyWindow(hDlg);
					break;
				case IDM_HELP_ABOUT:
					//EndDialog(hDlg, LOWORD(wParam));
					DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hDlg, (DLGPROC)About);
					break;
				case IDM_MENU_SEARCH:
					EndDialog(hDlg, LOWORD(wParam));
					gbSearch = FALSE;
					DialogBox(g_hInst, (LPCTSTR)IDD_SEARCHBOX, GetParent(hDlg), (DLGPROC)SearchBox);
					//gSearchPageNum = 0;
					//gSearchPageNumMax = 0;
					gPages.clearPages();
					SendMessage (GetParent(hDlg), WM_USER, ID_DO_SEARCH, 0);
					break;

				case IDM_COPY:

					hWndEditBox = GetDlgItem(hDlg, ID_CHAPTER_TEXT);
					SendMessage (hWndEditBox, WM_COPY, 0, 0);
					break;
				case IDM_WHBBIBLE_NEXT:

					if (g_ChapterDisplay.iChapter < CHAPTERS[g_ChapterDisplay.iBook] - 1) {
						//stay in current book
						g_ChapterDisplay.iChapter++;
					}
					else {
						//move to next book
						if (g_ChapterDisplay.iBook < BOOKS_IN_BIBLE - 1) {
							g_ChapterDisplay.iBook++;
							g_ChapterDisplay.iChapter = 0;
						} else break;
						
					}

					SetChapterText();
					SetDlgItemText(hDlg, ID_CHAPTER_TEXT, gpszChapterText);

//					EndDialog(hDlg, LOWORD(wParam));
//					SendMessage (GetParent(hDlg), WM_USER, ID_READ_CHAPTER, 0);

					break;
				
				case IDM_WHBBIBLE_PREV:
					if (g_ChapterDisplay.iChapter > 0) {
						//stay in current book
						g_ChapterDisplay.iChapter--;
					}
					else {
						//move to next book
						if (g_ChapterDisplay.iBook > 0) {
							g_ChapterDisplay.iBook--;
							g_ChapterDisplay.iChapter = CHAPTERS[g_ChapterDisplay.iBook] - 1;
						} else break;
						
					}
					SetChapterText();
					SetDlgItemText(hDlg, ID_CHAPTER_TEXT, gpszChapterText);
//					EndDialog(hDlg, LOWORD(wParam));
//					SendMessage (GetParent(hDlg), WM_USER, ID_READ_CHAPTER, 0);

					break;
				
				case IDOK:
					EndDialog(hDlg, LOWORD(wParam));
					break;
				default:
				   return DefWindowProc(hDlg, message, wParam, lParam);
			}
			break;


		default:
			break;
			
	}
	return DefWindowProc (hDlg, message, wParam, lParam) ;
//    return TRUE;
}

