
#if !defined(AFX_WHBBIBLE_H__33A5FBF3_0DAA_46D8_B0D5_4588DC92BCF1__INCLUDED_)
#define AFX_WHBBIBLE_H__33A5FBF3_0DAA_46D8_B0D5_4588DC92BCF1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"

#define ID_LISTVIEW		1000
#define ID_SCROLLBAR	1001
#define EDITCONTROL		1002
#define ID_LISTBOX		1003
#define ID_CHAPTER_TEXT 1004
#define	ID_DO_SEARCH	2000
#define	ID_READ_CHAPTER	2001


#define MENU_HEIGHT 26

#define NUM_COLUMNS		1
#define NUM_ITEMS       22
#define MAX_ITEMLEN     64
#define MAX_BOOK		25
#define MAX_VERSETEXT	700
#define NUM_TOKENS		30  //max number of key words
#define MAX_TOKENSTR	700 //max input in box
#define MAX_RESULTS		100
#define MAX_LOADSTRING	100
#define LEFT_MARGIN		10
#define MARGINS			10
#define MAX_CHAPTER		16000

#define BITMAP_WIDTH    8
#define BITMAP_HEIGHT   11
#define MAX_LINES_PER_VERSE 20
#define WELCOME_SLEEP	2000
#define CONCORDANCE_PREFACE 10

#define HEADER_LEN		32

#ifdef WIN32
#define LONG2POINT(l, pt)  ((pt).x = (SHORT)LOWORD(l), (pt).y = (SHORT)HIWORD(l))
#else
#define LONG2POINT(l, pt)  ((pt).x = (INT)LOWORD(l), (pt).y = (INT)HIWORD(l))
#endif

const int COL_WIDTH[] = { 50, 15, 15, 160 };





/*
const char BIBLE_VERSION[4][6] = {
		"NIV\\",		"KJV\\",		"NASB\\",	"NLT\\"
};

const TCHAR VERSION[4][5] = {
		L"NIV",		L"KJV",		L"NASB",	L"NLT"
};
*/



const TCHAR END_OF_RESULTS[] = TEXT("------[End of Results]-----");


// structures
typedef struct tagSEARCHRESULT
{
    TCHAR szBook[MAX_BOOK];
	int iChapter;
	int iVerse;
    TCHAR szVerseText[MAX_VERSETEXT];

} SEARCHRESULT;


typedef struct _searchtype {
	int		len;  //string length
	int		version;
	int		book;
	int		chapter;
	int		verse;
	BOOL	alloc;
	TCHAR * str;  //lptsr
} SEARCHTYPE;



#endif // !defined(AFX_WHBBIBLE_H__33A5FBF3_0DAA_46D8_B0D5_4588DC92BCF1__INCLUDED_)
